##########################################################################
#
# StudioFactory
#
# The desktop Audio/Video studio.
# Copyright (C) 2002-2004  Peter Wendrich (pwsoft@syntiac.com)
# Homepage: http://www.syntiac.com/studiofactory.html
#
##########################################################################
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
##########################################################################
#
# Color selector window
#
##########################################################################

my $noofCableColors=8;

$rd .= "static const int noofCableColors=$noofCableColors;\n";
$rv .= "static int currentCableColorIndex=0;\n";
#  $rv .= "static int cablePenColors[noofCableColors] ={0000,0004,0040,0400,0044,0404,0440,0444};\n";
#  $rv .= "static int cableFillColors[noofCableColors]={0333,0007,0070,0700,0077,0707,0770,0xFFFFFF};\n";
$rv .= "static int cablePenColors[noofCableColors] ={0x000000,0x000088,0x008800,0x880000,0x008888,0x880088,0x888800,0x888888};\n";
$rv .= "static int cableFillColors[noofCableColors]={0x666666,0x0000BB,0x00BB00,0xBB0000,0x00BBBB,0xBB00BB,0xBBBB00,0xFFFFFF};\n";
$rc .= <<EOF;
static void setCurrentCableColor(int index) {
  int i;

  currentCableColorIndex=index;
  colorSelectorWindowRefresh=true;
  for(i=0;i<noofCableColors;i++) {
    markMenuItem(mainMenu, MENU_CABLECOLOR_0+i, i==index);
    markMenuItem(synFactoryMenu, MENU_CABLECOLOR_0+i, i==index);
//    for(j=0;j<noofLanguages;j++) {
      // !!! make platform independed
//      CheckMenuItem(mainMenu[j], MENU_CABLECOLOR_0+i, MF_BYCOMMAND | ((i==index)?MF_CHECKED:MF_UNCHECKED));
//      CheckMenuItem(synFactoryMenu[j], MENU_CABLECOLOR_0+i, MF_BYCOMMAND | ((i==index)?MF_CHECKED:MF_UNCHECKED));
//    }
  }
}
static void cableColorHandler(ContextPtr aContext) {
  switch (aContext->guiEvent) {
  case GUIEVENT_REFRESH: {
      guiClearAreaList(aContext);
      DrawEdge(aContext->hdc, &(aContext->guiClientRect), EDGE_SUNKEN, BF_MIDDLE);

      GuiRect myRect;
      for(int i=0; i<noofCableColors; i++) {
        myRect.top = ((i*2)/noofCableColors)*32+2;
        myRect.bottom = ((i*2)/noofCableColors)*32+30;
        myRect.left = (i&(noofCableColors/2-1))*32+34;
        myRect.right = (i&(noofCableColors/2-1))*32+62;

        DrawEdge(aContext->hdc, &myRect, (i==currentCableColorIndex)?EDGE_SUNKEN:EDGE_RAISED, BF_MIDDLE | BF_RECT);
        guiSelectPen3Color(aContext, cablePenColors[i]);
        guiSelectFillColor(aContext, cableFillColors[i]);
        Ellipse(aContext->hdc, ((i==currentCableColorIndex)?1:0)+myRect.left+6, ((i==currentCableColorIndex)?1:0)+myRect.top+6, ((i==currentCableColorIndex)?1:0)+myRect.left+22, ((i==currentCableColorIndex)?1:0)+myRect.top+22);
        guiAddArea(aContext, myRect.left, myRect.top, myRect.right, myRect.bottom);
      }
      
      myRect.top = 2;
      myRect.bottom = 30;
      myRect.left = 2;
      myRect.right = 30;
      int offs=(showResizeMarkers)?1:0;
      DrawEdge(aContext->hdc, &myRect, (showResizeMarkers)?EDGE_SUNKEN:EDGE_RAISED, BF_MIDDLE | BF_RECT);
      guiSelectPen1Color(aContext, 0x000000);
      guiSelectFillColor(aContext, -1);
      guiDrawRect(aContext, 10+offs, 10+offs, 20+offs, 20+offs);
      guiSelectPen1Color(aContext, 0x000000);
      guiSelectFillColor(aContext, 0xFFFFFF);
      guiDrawRect(aContext,  6+offs,  6+offs, 10+offs, 10+offs);
      guiDrawRect(aContext,  6+offs, 20+offs, 10+offs, 24+offs);
      guiDrawRect(aContext, 20+offs,  6+offs, 24+offs, 10+offs);
      guiDrawRect(aContext, 20+offs, 20+offs, 24+offs, 24+offs);
      guiAddArea(aContext, myRect.left, myRect.top, myRect.right, myRect.bottom);

      myRect.top = 34;
      myRect.bottom = 62;
      myRect.left = 2;
      myRect.right = 30;
      DrawEdge(aContext->hdc, &myRect, (showResizeMarkers)?EDGE_SUNKEN:EDGE_RAISED, BF_MIDDLE | BF_RECT);
    } break;
  case GUIEVENT_MOUSEBUTTON1DOWN:
    if (aContext->id>0 && aContext->id<=noofCableColors) {
      setCurrentCableColor(aContext->id-1);
    }
    if (aContext->id>noofCableColors) {
      showResizeMarkers=!showResizeMarkers;
      colorSelectorWindowRefresh=true;
      mainWindowRefresh=true;
    }
    break;
  case GUIEVENT_KEYDOWN:
    switch(aContext->id) {
    case VK_ESCAPE:
      guiHideWindow(aContext->currentWindow);
      break;
    default:
      break;
    } break;
  case GUIEVENT_CLOSE:
    guiHideWindow(aContext->currentWindow);
    break;
  default:
    break;
  }
}
EOF

genWindow('colorSelectorWindow', 'COLORSELECTORWINDOW', '"Color Selector"', 'cableColorHandler', ($noofCableColors+2)*16, 64, 0, 0, 1);
push(@initFunctions, "setCurrentCableColor(0);\n");
